#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <fcntl.h>
#include <sys/mman.h>
#include <ctype.h>
#include <fcntl.h>
#include "cfxga.h"
//#include <asm/sharp_char.h>

int main(int argc, char *argv[])
{
    unsigned short *scrnbuf, *sb2;
    unsigned long rez;
    int fd, fbfd, i, lfd;
//    sharp_led_status led;
    struct cfxgaset desc = { 0, 0, 640, 480, 16, 1280, NULL };
    struct cfxgaget info;
     struct cfxgainfo status;

    fd = open("/home/QtPalmtop/bin/chkhinge", O_RDONLY);
    if(fd < 0) {
	desc.width = 240;
	desc.height = 320;
	desc.stride = 480;
    } else
	close(fd);

    fd = open("/dev/cfxga0a", O_RDWR);
    if(fd < 0) {
	printf("No CFXGA card\n");
	return -1;
    }
//#if 0
    // read info
    ioctl(fd, CFXGAINFO, &status);
    printf("%lxx %lxx\n", status.x, status.y);
//#endif

    if(argc != 2 || !isdigit(argv[1][0])) {
	printf("usage: cfxgamirror [mode]\n Available modes:\n");
	// display data for all modes
	ioctl(fd, CFXGANUMMODES, &rez);
	for(i = 0; i < rez; i++) {
	    info.mode = i;
	    ioctl(fd, CFXGAGETMODE, &info);
	    printf("%2ld: W=%ld H=%ld vf=%-2ld d=%ld hf=%ld vid=%02lx\n", info.mode, info.width, info.height, info.vfreq,
	      info.depth, info.hfreq, info.appl);
	}
	close(fd);
	return 1;
    }

    rez = atoi(argv[1]);

    // get mode stats
    info.mode = rez;
    ioctl(fd, CFXGAGETMODE, &info);
    // display mode specs
//#if 0
    printf("%2ld: W=%ld H=%ld vf=%-2ld d=%ld hf=%ld vid=%02lx\n", info.mode, info.width, info.height, info.vfreq, info.depth,
      info.hfreq, info.appl);
//#endif
    // center sharp screen on output
    desc.left = (info.width - desc.width) / 2;
    desc.top = (info.height - desc.height) / 2;
    // set mode 
    ioctl(fd, CFXGASETMODE, &rez);
    // clear screen
    ioctl(fd, CFXGACLEAR, NULL);
    // map screen buffer
    fbfd = open("/dev/fb0", O_RDONLY);	// I'm not sure when I can close this
    sb2 = mmap(0, desc.width * desc.height * 2, PROT_READ, MAP_PRIVATE, fbfd, 0);
    // a normal malloc or global may work, but to be safe...
    scrnbuf = mmap(0, desc.width * desc.height * 2, PROT_READ | PROT_WRITE, MAP_PRIVATE | MAP_ANONYMOUS, -1, 0);
    desc.image = scrnbuf;

//    led.which = 13;
//    lfd = open("/dev/sharp_led", O_RDWR);
    // update the image a little slower than every second
    for(;;) {
	unsigned char *r, *s;
	register unsigned int step = (desc.height << 1) - 1;
//	led.status = 2;
//	ioctl(lfd, SHARP_LED_SETSTATUS, &led);
	// copy screen (horizontal v.s. vertical frame buffers)
	for(rez = 0; rez < desc.height; rez++) {
	    s = &sb2[desc.height - 1 - rez];
	    r = &scrnbuf[rez * desc.width];
	    i = desc.width;
	    while(i--) {
		*r++ = *s++;
		*r++ = *s;
		s += step;
	    }
	}
	// send to VGA chip
	ioctl(fd, CFXGAWRITERECT, &desc);
//	led.status = 1;
//	ioctl(lfd, SHARP_LED_SETSTATUS, &led);
	sleep(1);
    }
}
